## ros-dashing-async-web-server-cpp 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(async_web_server_cpp)

find_package(ament_cmake_ros REQUIRED)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS thread system regex filesystem)
find_package(OpenSSL)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

###################################################
## Declare things to be passed to other projects ##
###################################################

###########
## Build ##
###########

## Specify additional locations of header files
include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${OPENSSL_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME} src/http_server.cpp
  src/http_connection.cpp src/http_request_parser.cpp
  src/http_reply.cpp src/http_request_handler.cpp
  src/websocket_connection.cpp src/websocket_request_handler.cpp
  src/websocket_message.cpp src/http_request.cpp)

target_link_libraries(${PROJECT_NAME}
  ${OPENSSL_LIBRARIES}
  ${Boost_LIBRARIES}
)

ament_export_dependencies(OpenSSL)
ament_export_include_directories(include ${Boost_INCLUDE_DIRS})
ament_export_libraries(${PROJECT_NAME} ${Boost_LIBRARIES})

ament_package()

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
  FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h"
)


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
add_executable(test_web_server test_web_server.cpp)
set_target_properties(test_web_server PROPERTIES
  COMPILE_DEFINITIONS "ASYNC_WEB_SERVER_CPP_TEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"")
target_link_libraries(test_web_server ${PROJECT_NAME})

set(generated_test_file "${CMAKE_CURRENT_BINARY_DIR}/tests")
set(TEST_WEB_SERVER_EXECUTABLE $<TARGET_FILE:test_web_server>)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/tests.py.in"
  "${generated_test_file}.py.genexp"
  @ONLY)
file(GENERATE
  OUTPUT "${generated_test_file}_$<CONFIG>.py"
  INPUT "${generated_test_file}.py.genexp"
)
ament_add_test(tests
  COMMAND "${generated_test_file}_$<CONFIG>.py"
  GENERATE_RESULT_FOR_RETURN_CODE_ZERO)

=== debian/changelog ===
ros-dashing-async-web-server-cpp (1.0.0-1bionic) bionic; urgency=high

  * Port to ROS 2

 -- Russell Toris <russell.toris@gmail.com>  Thu, 19 Sep 2019 07:00:00 -0000

ros-dashing-async-web-server-cpp (0.0.3-1bionic) bionic; urgency=high

  * Merge pull request #6 from mitchellwills/develop
    Added some tests
  * Added filesystem tests
  * Added some more tests (including websocket tests)
  * Added some more http tests
  * Added an echo test and enabled tests on travis
  * Began working on some tests
  * Fixed missing boost dep
  * Merge pull request #5 from mitchellwills/develop
    Some more improvements
  * Added filesystem request handler
    This serves both files from a given root and directory listings (if requested)
  * Modified request handler signature so that it can reject requests (causing them to be pushed to the next handler in a handler group)
  * Now load a file to be served each time it is requested
  * Fix HTTP Server stop to allow it to be safe to call multiple times
  * Merge pull request #4 from mitchellwills/develop
    A few small improvements
  * Allow for a server to be created even if the system has no non-local IP
    See http://stackoverflow.com/questions/5971242/how-does-boost-asios-hostname-resolution-work-on-linux-is-it-possible-to-use-n
  * Changed write resource to be a const shared ptr
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <russell.toris@gmail.com>  Tue, 18 Aug 2015 07:00:00 -0000

ros-dashing-async-web-server-cpp (0.0.2-1bionic) bionic; urgency=high

  * Merge pull request #3 from mitchellwills/develop
    Added support for specifying additional headers when creating static request handlers
  * Added some comments to the HTTP reply methods
  * Added support for specifying additional headers when creating static request handlers
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <russell.toris@gmail.com>  Tue, 06 Jan 2015 08:00:00 -0000

ros-dashing-async-web-server-cpp (0.0.1-1bionic) bionic; urgency=high

  * OCD clenup
  * Merge pull request #2 from mitchellwills/develop
    Few small fixes
  * Fixed message processing so close message is actually passed through
  * Fixed potential memory leak from boost shared_ptr misuse
  * Merge pull request #1 from mitchellwills/develop
    Import of initial implementation from webrtc_ros repo
  * Fixed install directives
  * Added some documentation
  * Added more metadata files
  * Cleaned up file formatting
  * Fixed compilation error on 12.04
  * Added boost dependancy
  * Added travis configuration
  * Package cleanup
  * renamed package to async_web_server_cpp
  * Initial import of cpp_web_server from webrtc_ros
  * Initial commit
  * Contributors: Mitchell Wills, Russell Toris

 -- Russell Toris <russell.toris@gmail.com>  Tue, 02 Dec 2014 08:00:00 -0000

=== debian/control ===
Source: ros-dashing-async-web-server-cpp
Section: misc
Priority: extra
Maintainer: Russell Toris <russell.toris@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libssl-dev, python3-websocket, ros-dashing-ament-cmake-ros, ros-dashing-launch-testing, ros-dashing-ros-workspace
Homepage: http://ros.org/wiki/async_web_server_cpp
Standards-Version: 3.9.2

Package: ros-dashing-async-web-server-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libssl-dev, ros-dashing-ros-workspace
Description: Asynchronous Web/WebSocket Server in C++

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DCMAKE_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-async-web-server-cpp//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
